## avrdude 7.1+dfsg

=== CMakeLists.txt ===
#
# CMakeLists.txt - CMake project for AVRDUDE
# Copyright (C) 2021 Marius Greuel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

# Typical usage:
#     cmake -B build
#     cmake --build build

cmake_minimum_required(VERSION 3.14)
project(avrdude VERSION 7.1 LANGUAGES C)

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED True)

option(BUILD_DOC "Enable building documents" OFF)
option(HAVE_LINUXGPIO "Enable Linux sysfs GPIO support" OFF)
option(HAVE_LINUXSPI "Enable Linux SPI support" OFF)
option(HAVE_PARPORT "Enable parallel port support" OFF)
option(USE_EXTERNAL_LIBS "Use external libraries from AVRDUDE GitHub repositories" OFF)
option(USE_LIBUSBWIN32 "Prefer libusb-win32 over libusb" OFF)
option(DEBUG_CMAKE "Enable debugging output for this CMake project" OFF)
option(BUILD_SHARED_LIBS "Build shared libraries" OFF)

if(WIN32)
    # Prefer static libraries over DLLs on Windows
    option(USE_STATIC_LIBS "Use static libraries" ON)
else()
    option(USE_STATIC_LIBS "Use static libraries" OFF)
endif()

include(CheckIncludeFile)
include(CheckSymbolExists)
include(FetchContent)
include(FindPackageMessage)
include(GNUInstallDirs)

set(CONFIG_DIR "${CMAKE_INSTALL_FULL_SYSCONFDIR}")
set(AVRDUDE_FULL_VERSION ${CMAKE_PROJECT_VERSION})

# =====================================
# Get Git commit info
# =====================================

# GIT_COMMIT_HASH -> hash of latest commit, e.g. b8b859f5
# GIT_COMMIT_DATE -> date of latest commit, e.g. 20201231
# GIT_COMMIT_YEAR -> year of latest commit, e.g. 2020

find_package(Git)
if(Git_FOUND)
    execute_process(
        COMMAND "${GIT_EXECUTABLE}" log -1 --format=%h
        WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
        OUTPUT_VARIABLE GIT_COMMIT_HASH
        ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE
        )

    execute_process(
        COMMAND "${GIT_EXECUTABLE}" log -1 --format=%ad --date=format:%Y%m%d
        WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
        OUTPUT_VARIABLE GIT_COMMIT_DATE
        ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE
        )

    execute_process(
        COMMAND "${GIT_EXECUTABLE}" log -1 --format=%ad --date=format:%Y
        WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
        OUTPUT_VARIABLE GIT_COMMIT_YEAR
        ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE
        )

    execute_process(
        COMMAND "${GIT_EXECUTABLE}" log -1 --tags --format=%h
        WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
        OUTPUT_VARIABLE GIT_TAG_HASH
        ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE
        )

    # If the commit is not tagged, include the date and commit hash in the full version string.
    if(NOT GIT_COMMIT_HASH STREQUAL GIT_TAG_HASH)
        set(AVRDUDE_FULL_VERSION "${CMAKE_PROJECT_VERSION}-${GIT_COMMIT_DATE} (${GIT_COMMIT_HASH})")
    endif()
endif()

find_package(FLEX)
if(NOT FLEX_FOUND)
    message(SEND_ERROR "This CMake project requires 'flex', which is not installed on your system." )
endif()

find_package(BISON QUIET)
if(BISON_FOUND)
    find_package_message(BISON "Found BISON: ${BISON_EXECUTABLE} (found version \"${BISON_VERSION}\")" "[${BISON_EXECUTABLE}][${BISON_VERSION}]")
else()
    find_program(YACC_EXECUTABLE NAMES yacc byacc DOC "path to the yacc executable")
    mark_as_advanced(YACC_EXECUTABLE)
    if(YACC_EXECUTABLE)
        find_package_message(YACC "Found YACC: ${YACC_EXECUTABLE}" "[${YACC_EXECUTABLE}]")
    else()
        message(SEND_ERROR "This CMake project requires 'bison', 'yacc', or 'byacc', which is not installed on your system." )
    endif()
endif()

# =====================================
# Detect installed libraries
# =====================================

if(USE_STATIC_LIBS)
    set(PREFERRED_LIBELF libelf.a elf)
    set(PREFERRED_LIBUSB libusb.a usb)
    set(PREFERRED_LIBUSB_1_0 libusb-1.0.a usb-1.0)
    set(PREFERRED_LIBHIDAPI libhidapi.a libhidapi-libusb.a libhidapi-hidraw.a hidapi hidapi-libusb hidapi-hidraw)
    set(PREFERRED_LIBFTDI libftdi.a ftdi)
    set(PREFERRED_LIBFTDI1 libftdi1.a ftdi1)
    set(PREFERRED_LIBREADLINE libreadline.a)
else()
    set(PREFERRED_LIBELF elf)
    set(PREFERRED_LIBUSB usb)
    set(PREFERRED_LIBUSB_1_0 usb-1.0)
    set(PREFERRED_LIBHIDAPI hidapi hidapi-libusb hidapi-hidraw)
    set(PREFERRED_LIBFTDI ftdi)
    set(PREFERRED_LIBFTDI1 ftdi1)
    set(PREFERRED_LIBREADLINE readline)
endif()

# -------------------------------------
# Find libelf

find_library(HAVE_LIBELF NAMES ${PREFERRED_LIBELF})
if(HAVE_LIBELF)
    set(LIB_LIBELF ${HAVE_LIBELF})
    check_include_file(libelf.h HAVE_LIBELF_H)
    check_include_file(libelf/libelf.h HAVE_LIBELF_LIBELF_H)
endif()

# -------------------------------------
# Find libusb

find_library(HAVE_LIBUSB NAMES ${PREFERRED_LIBUSB})
if(HAVE_LIBUSB)
    set(LIB_LIBUSB ${HAVE_LIBUSB})
endif()

find_library(HAVE_LIBUSB_1_0 NAMES ${PREFERRED_LIBUSB_1_0})
if(HAVE_LIBUSB_1_0)
    set(LIB_LIBUSB_1_0 ${HAVE_LIBUSB_1_0})
endif()

# FreeBSD's library 'libusb' supports both the libusb-0.1 and libusb-1.0 API.
if (HAVE_LIBUSB AND CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
    set(HAVE_LIBUSB_1_0 ${HAVE_LIBUSB})
endif()

find_library(HAVE_LIBUSB_WIN32 NAMES libusb0.a usb0)

if(HAVE_LIBUSB OR HAVE_LIBUSB_1_0 OR HAVE_LIBUSB_WIN32)
    check_include_file(usb.h HAVE_USB_H)
    check_include_file(lusb0_usb.h HAVE_LUSB0_USB_H)
    check_include_file(libusb.h HAVE_LIBUSB_H)
    check_include_file(libusb-1.0/libusb.h HAVE_LIBUSB_1_0_LIBUSB_H)

    if((USE_LIBUSBWIN32 OR NOT HAVE_LIBUSB) AND HAVE_LIBUSB_WIN32)
        set(HAVE_LIBUSB ${HAVE_LIBUSB_WIN32})
        set(LIB_LIBUSB ${HAVE_LIBUSB_WIN32})
        unset(HAVE_USB_H CACHE)
    elseif(NOT HAVE_USB_H)
        find_path(LIBUSB_COMPAT_DIR libusb-compat/usb.h)
        if(LIBUSB_COMPAT_DIR)
            set(LIBUSB_COMPAT_DIR ${LIBUSB_COMPAT_DIR}/libusb-compat)
            set(HAVE_USB_H 1)
        else()
            unset(LIBUSB_COMPAT_DIR CACHE)
        endif()
    endif()
endif()

# -------------------------------------
# Find libhidapi

find_library(HAVE_LIBHID NAMES hid)
if(HAVE_LIBHID)
    set(LIB_LIBHID ${HAVE_LIBHID})
endif()

find_library(HAVE_LIBHIDAPI NAMES ${PREFERRED_LIBHIDAPI})
if(HAVE_LIBHIDAPI)
    set(LIB_LIBHIDAPI ${HAVE_LIBHIDAPI})
    check_include_file(hidapi/hidapi.h HAVE_HIDAPI_HIDAPI_H)
endif()

# -------------------------------------
# Find libftdi

find_library(HAVE_LIBFTDI NAMES ${PREFERRED_LIBFTDI})
if(HAVE_LIBFTDI)
    set(LIB_LIBFTDI ${HAVE_LIBFTDI})
    set(HAVE_LIBFTDI_TYPE_232H 1)
endif()

find_library(HAVE_LIBFTDI1 NAMES ${PREFERRED_LIBFTDI1})
if(HAVE_LIBFTDI1)
    set(LIB_LIBFTDI1 ${HAVE_LIBFTDI1})
    set(HAVE_LIBFTDI_TYPE_232H 1)
    set(CMAKE_REQUIRED_LIBRARIES ${LIB_LIBFTDI1} ${LIB_LIBUSB} ${LIB_LIBUSB_1_0})
    check_symbol_exists(ftdi_tcioflush "libftdi1/ftdi.h" HAVE_FTDI_TCIOFLUSH)
endif()

# -------------------------------------
# Find libreadline

find_library(HAVE_LIBREADLINE NAMES ${PREFERRED_LIBREADLINE})
if(HAVE_LIBREADLINE)
    set(LIB_LIBREADLINE ${HAVE_LIBREADLINE})
elseif(MSVC)
    set(HAVE_LIBREADLINE 1)
endif()

# =====================================
# Use external libraries if requested
# =====================================

if(USE_EXTERNAL_LIBS)
    FetchContent_Declare(libelf
        GIT_REPOSITORY https://github.com/avrdudes/libelf.git
        GIT_TAG e5a39bf19bd6598c42e09172be5a78ceec2a065c
        )

    FetchContent_Declare(libusb
        GIT_REPOSITORY https://github.com/avrdudes/libusb.git
        GIT_TAG 632bc25d04eff563cc00de29435b9a7ed6f4654c
        )

    FetchContent_Declare(libhidapi
        GIT_REPOSITORY https://github.com/avrdudes/libhidapi.git
        GIT_TAG d1307487973c857bc158e27ecc99644b2f5e68ea
        )

    FetchContent_Declare(libftdi
        GIT_REPOSITORY https://github.com/avrdudes/libftdi.git
        GIT_TAG f9fe6e96b97c3a08efd081632c1859cb83aa14e3
        )

    message(STATUS "Fetching external libraries, please wait...")
    FetchContent_MakeAvailable(
        libelf
        libusb
        libhidapi
        libftdi
        )

    message(STATUS "Using external library 'libelf'")
    set(LIB_LIBELF libelf)
    set(HAVE_LIBELF 1)
    set(HAVE_LIBELF_H 1)

    message(STATUS "Using external library 'libusb'")
    set(LIB_LIBUSB libusb)
    set(HAVE_LIBUSB 1)
    set(HAVE_LUSB0_USB_H 1)

    message(STATUS "Using external library 'libhidapi'")
    set(LIB_LIBHIDAPI libhidapi)
    set(HAVE_LIBHIDAPI 1)
    set(HAVE_HIDAPI_HIDAPI_H 1)

    message(STATUS "Using external library 'libftdi'")
    set(LIB_LIBFTDI libftdi)
    set(HAVE_LIBFTDI 1)
    set(HAVE_LIBFTDI_TYPE_232H 1)
endif()

add_subdirectory(src)

if(BUILD_DOC)
    add_subdirectory(src/doc)
endif()

# =====================================
# Configuration
# =====================================

message(STATUS "Configuration summary:")
message(STATUS "----------------------")

if (DEBUG_CMAKE)
    message(STATUS "CMAKE_HOST_SYSTEM: ${CMAKE_HOST_SYSTEM}")
    message(STATUS "CMAKE_SYSTEM: ${CMAKE_SYSTEM}")
    message(STATUS "CMAKE_FIND_ROOT_PATH: ${CMAKE_FIND_ROOT_PATH}")
    message(STATUS "CMAKE_C_COMPILER: ${CMAKE_C_COMPILER}")
    message(STATUS "CONFIG_DIR: ${CONFIG_DIR}")
    message(STATUS "AVRDUDE_FULL_VERSION: ${AVRDUDE_FULL_VERSION}")
    message(STATUS "USE_EXTERNAL_LIBS: ${USE_EXTERNAL_LIBS}")
    message(STATUS "USE_LIBUSBWIN32: ${USE_LIBUSBWIN32}")
    message(STATUS "HAVE_LIBELF: ${HAVE_LIBELF}")
    message(STATUS "HAVE_LIBUSB: ${HAVE_LIBUSB}")
    message(STATUS "HAVE_LIBUSB_1_0: ${HAVE_LIBUSB_1_0}")
    message(STATUS "HAVE_LIBUSB_WIN32: ${HAVE_LIBUSB_WIN32}")
    message(STATUS "HAVE_LIBHID: ${HAVE_LIBHID}")
    message(STATUS "HAVE_LIBHIDAPI: ${HAVE_LIBHIDAPI}")
    message(STATUS "HAVE_LIBFTDI: ${HAVE_LIBFTDI}")
    message(STATUS "HAVE_LIBFTDI1: ${HAVE_LIBFTDI1}")
    message(STATUS "HAVE_LIBREADLINE: ${HAVE_LIBREADLINE}")
    message(STATUS "HAVE_LIBELF_H: ${HAVE_LIBELF_H}")
    message(STATUS "HAVE_LIBELF_LIBELF_H: ${HAVE_LIBELF_LIBELF_H}")
    message(STATUS "HAVE_USB_H: ${HAVE_USB_H}")
    message(STATUS "HAVE_LUSB0_USB_H: ${HAVE_LUSB0_USB_H}")
    message(STATUS "HAVE_LIBUSB_H: ${HAVE_LIBUSB_H}")
    message(STATUS "HAVE_LIBUSB_1_0_LIBUSB_H: ${HAVE_LIBUSB_1_0_LIBUSB_H}")
    message(STATUS "HAVE_HIDAPI_HIDAPI_H: ${HAVE_HIDAPI_HIDAPI_H}")
    message(STATUS "LIBUSB_COMPAT_DIR: ${LIBUSB_COMPAT_DIR}")
    message(STATUS "----------------------")
endif()

if(HAVE_LIBELF)
    message(STATUS "DO HAVE    libelf")
else()
    message(STATUS "DON'T HAVE libelf")
endif()

if(HAVE_LIBUSB)
    message(STATUS "DO HAVE    libusb")
else()
    message(STATUS "DON'T HAVE libusb")
endif()

if(HAVE_LIBUSB_1_0)
    message(STATUS "DO HAVE    libusb_1_0")
else()
    message(STATUS "DON'T HAVE libusb_1_0")
endif()

if(HAVE_LIBHIDAPI)
    message(STATUS "DO HAVE    libhidapi")
else()
    message(STATUS "DON'T HAVE libhidapi")
endif()

if(HAVE_LIBFTDI)
    if(HAVE_LIBFTDI1)
        message(STATUS "DO HAVE    libftdi (but prefer to use libftdi1)")
    else()
        message(STATUS "DO HAVE    libftdi")
    endif()
else()
    message(STATUS "DON'T HAVE libftdi")
endif()

if(HAVE_LIBFTDI1)
    message(STATUS "DO HAVE    libftdi1")
else()
    message(STATUS "DON'T HAVE libftdi1")
endif()

if(HAVE_LIBREADLINE)
    message(STATUS "DO HAVE    libreadline")
else()
    message(STATUS "DON'T HAVE libreadline")
endif()

if(BUILD_DOC)
	message(STATUS "ENABLED    doc")
else()
	message(STATUS "DISABLED   doc")
endif()

if(HAVE_PARPORT)

=== src/CMakeLists.txt ===
#
# CMakeLists.txt - CMake project for AVRDUDE
# Copyright (C) 2021 Marius Greuel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

# =====================================
# Set up flex target
# =====================================

FLEX_TARGET(Parser "lexer.l" "${PROJECT_BINARY_DIR}/lexer.c")

if (FLEX_VERSION VERSION_GREATER_EQUAL 2.5.9)
    set(HAVE_YYLEX_DESTROY 1)
endif()

# =====================================
# Set up yacc/bison target
# =====================================

if(BISON_FOUND)
    BISON_TARGET(Parser config_gram.y "${PROJECT_BINARY_DIR}/config_gram.c" DEFINES_FILE "${PROJECT_BINARY_DIR}/config_gram.h")
else()
    set(YACC_TARGET_outputs "${PROJECT_BINARY_DIR}/config_gram.c")
    add_custom_command(OUTPUT ${YACC_TARGET_outputs}
        COMMAND ${YACC_EXECUTABLE} -d -o ${YACC_TARGET_outputs} config_gram.y
        VERBATIM
        COMMENT "[YACC][Parser] Building parser with yacc"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
    set(BISON_Parser_OUTPUTS ${YACC_TARGET_outputs})
endif()

# =====================================
# Setup target specific options
# =====================================

include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR})
add_compile_definitions(CONFIG_DIR=\"${CONFIG_DIR}\")

if(WIN32)
    set(EXTRA_WINDOWS_RESOURCES "${PROJECT_BINARY_DIR}/src/windows.rc")
    set(EXTRA_WINDOWS_LIBRARIES setupapi ws2_32)
endif()

if(MSVC)
    enable_language(CXX)

    add_compile_definitions(_CRT_SECURE_NO_WARNINGS=1)
    add_compile_definitions(_CRT_NONSTDC_NO_WARNINGS=1)
    add_compile_definitions(_WINSOCK_DEPRECATED_NO_WARNINGS=1)
    add_compile_options(/W3)
    add_compile_options(/wd4018) # warning C4018: signed/unsigned mismatch
    add_compile_options(/wd4244) # warning C4244: conversion from '...' to '...', possible loss of data
    add_compile_options(/wd4267) # warning C4267: conversion from '...' to '...', possible loss of data

    set(EXTRA_WINDOWS_SOURCES ${EXTRA_WINDOWS_SOURCES}
        "msvc/getopt.c"
        "msvc/gettimeofday.c"
        "msvc/usleep.cpp"
        "msvc/readline.cpp"
        )
    set(EXTRA_WINDOWS_INCLUDES ${EXTRA_WINDOWS_INCLUDES}
        "msvc"
        )
else()
    set(LIB_MATH m)
    add_compile_options(-Wall) # -Wextra
endif()

# =====================================
# Setup default port names
# =====================================

if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(DEFAULT_PAR_PORT "/dev/parport0")
    set(DEFAULT_SER_PORT "/dev/ttyS0")
elseif (CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
    set(DEFAULT_PAR_PORT "/dev/ppi0")
    set(DEFAULT_SER_PORT "/dev/cuad0")
elseif (CMAKE_SYSTEM_NAME STREQUAL "Solaris")
    set(DEFAULT_PAR_PORT "/dev/printers/0")
    set(DEFAULT_SER_PORT "/dev/term/a")
elseif (CMAKE_SYSTEM_NAME STREQUAL "Windows")
    set(DEFAULT_PAR_PORT "lpt1")
    set(DEFAULT_SER_PORT "com1")
else()
    set(DEFAULT_PAR_PORT "unknown")
    set(DEFAULT_SER_PORT "unknown")
endif()

# =====================================
# Configure files
# =====================================

configure_file(cmake_config.h.in ac_cfg.h)
configure_file(avrdude.spec.in avrdude.spec)
if(WIN32)
    configure_file(windows.rc.in windows.rc)
endif()

add_custom_command(
    OUTPUT avrdude.conf
    COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_SOURCE_DIR}/avrdude.conf.in" avrdude.conf.in
    COMMAND ${CMAKE_COMMAND}
        -D HAVE_PARPORT=${HAVE_PARPORT}
        -D HAVE_LINUXSPI=${HAVE_LINUXSPI}
        -D HAVE_LINUXGPIO=${HAVE_LINUXGPIO}
        -D DEFAULT_PAR_PORT=${DEFAULT_PAR_PORT}
        -D DEFAULT_SER_PORT=${DEFAULT_SER_PORT}
        -P "${CMAKE_CURRENT_SOURCE_DIR}/configure.cmake"
    DEPENDS avrdude.conf.in
    VERBATIM
    )

add_custom_target(conf ALL DEPENDS avrdude.conf)

# =====================================
# Project
# =====================================

add_library(libavrdude
    ac_cfg.h
    arduino.h
    arduino.c
    avr.c
    avr910.c
    avr910.h
    avrcache.c
    avrdude.h
    avrftdi.c
    avrftdi.h
    avrftdi_private.h
    avrftdi_tpi.c
    avrftdi_tpi.h
    avrpart.c
    bitbang.c
    bitbang.h
    buspirate.c
    buspirate.h
    butterfly.c
    butterfly.h
    config.c
    config.h
    confwin.c
    crc16.c
    crc16.h
    dfu.c
    dfu.h
    fileio.c
    flip1.c
    flip1.h
    flip2.c
    flip2.h
    freebsd_ppi.h
    ft245r.c
    ft245r.h
    jtagmkI.c
    jtagmkI.h
    jtagmkI_private.h
    jtagmkII.c
    jtagmkII.h
    jtagmkII_private.h
    jtag3.c
    jtag3.h
    jtag3_private.h
    libavrdude.h
    linuxgpio.c
    linuxgpio.h
    linuxspi.c
    linuxspi.h
    linux_ppdev.h
    lists.c
    micronucleus.c
    micronucleus.h
    par.c
    par.h
    pgm.c
    pgm_type.c
    pickit2.c
    pickit2.h
    pindefs.c
    ppi.c
    ppi.h
    ppiwin.c
    serbb.h
    serbb_posix.c
    serbb_win32.c
    ser_avrdoper.c
    ser_posix.c
    ser_win32.c
    serialupdi.c
    serialupdi.h
    solaris_ecpp.h
    stk500.c
    stk500.h
    stk500_private.h
    stk500v2.c
    stk500v2.h
    stk500v2_private.h
    stk500generic.c
    stk500generic.h
    teensy.c
    teensy.h
    tpi.h
    updi_constants.h
    updi_link.c
    updi_link.h
    updi_nvm.c
    updi_nvm.h
    updi_readwrite.c
    updi_readwrite.h
    updi_state.c
    updi_state.h
    urclock.c
    urclock.h
    urclock_hash.h
    urclock_private.h
    usbasp.c
    usbasp.h
    usbdevs.h
    usb_hidapi.c
    usb_libusb.c
    usbtiny.h
    usbtiny.c
    update.c
    wiring.h
    wiring.c
    xbee.h
    xbee.c
    ${FLEX_Parser_OUTPUTS}
    ${BISON_Parser_OUTPUTS}
    "${EXTRA_WINDOWS_SOURCES}"
    )
    
set_target_properties(libavrdude PROPERTIES
    PREFIX ""
    PUBLIC_HEADER "libavrdude.h"
    VERSION 1.0.0
    SOVERSION 1
    )

target_include_directories(libavrdude
    PUBLIC
    "${PROJECT_SOURCE_DIR}"
    "${PROJECT_BINARY_DIR}"
    "${LIBUSB_COMPAT_DIR}"
    "${EXTRA_WINDOWS_INCLUDES}"
    )

target_link_libraries(libavrdude
    PUBLIC
    ${LIB_MATH}
    ${LIB_LIBELF}
    ${LIB_LIBUSB}
    ${LIB_LIBUSB_1_0}
    ${LIB_LIBHID}
    ${LIB_LIBHIDAPI}
    ${LIB_LIBFTDI}
    ${LIB_LIBFTDI1}
    ${LIB_LIBREADLINE}
    ${EXTRA_WINDOWS_LIBRARIES}
    )

add_executable(avrdude
    main.c
    term.c
    term.h
    avrintel.c
    avrintel.h
    developer_opts.c
    developer_opts.h
    developer_opts_private.h
    whereami.c
    whereami.h
    "${EXTRA_WINDOWS_RESOURCES}"
    )

target_link_libraries(avrdude PUBLIC libavrdude)

# =====================================
# Install
# =====================================

install(TARGETS avrdude DESTINATION bin)
install(TARGETS libavrdude
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION include COMPONENT dev
    )
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/avrdude.conf" TYPE SYSCONF)
install(FILES "avrdude.1"
	DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
	)

=== src/doc/CMakeLists.txt ===
#
# CMakeLists.txt - CMake project for AVRDUDE documentation
# Copyright (C) 2022 Marius Greuel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

set(AVRDUDE_CONF "${PROJECT_BINARY_DIR}/src/avrdude.conf")

set(TEXINFOS "${CMAKE_CURRENT_SOURCE_DIR}/avrdude.texi")
set(GENERATED_TEXINFOS
    programmers.texi
    programmer_types.texi
    parts.texi
    version.texi
    )

string(TIMESTAMP TODAY "%d %B %Y")
set(DOCS_VERSION ${PROJECT_VERSION})
set(DOCS_UPDATED ${TODAY})

find_program(MAKEINFO_EXECUTABLE NAMES makeinfo)
find_program(TEXI2HTML_EXECUTABLE NAMES texi2html)

# =====================================
# Custom rules for auto-generated texi
# =====================================

add_custom_target(avrdude_binaries DEPENDS avrdude conf)

add_custom_command(
    OUTPUT programmers.txt
    DEPENDS avrdude_binaries
    COMMAND $<TARGET_FILE:avrdude> -C ${AVRDUDE_CONF} -c ? 2>&1 | more > programmers.txt
    VERBATIM
    )

add_custom_command(
    OUTPUT programmer_types.txt
    DEPENDS avrdude_binaries
    COMMAND $<TARGET_FILE:avrdude> -C ${AVRDUDE_CONF} -c ?type 2>&1 | more > programmer_types.txt
    VERBATIM
    )

add_custom_command(
    OUTPUT parts.txt
    DEPENDS avrdude_binaries
    COMMAND $<TARGET_FILE:avrdude> -C ${AVRDUDE_CONF} -p ? 2>&1 | more > parts.txt
    VERBATIM
    )

add_custom_command(
    OUTPUT programmers.texi
    DEPENDS programmers.txt
    COMMAND ${CMAKE_COMMAND}
        -D TXT_FILE=programmers.txt
        -D TEXI_FILE=programmers.texi
        -P "${CMAKE_CURRENT_SOURCE_DIR}/programmers.cmake"
    VERBATIM
    )

add_custom_command(
    OUTPUT programmer_types.texi
    DEPENDS programmer_types.txt
    COMMAND ${CMAKE_COMMAND}
        -D TXT_FILE=programmer_types.txt
        -D TEXI_FILE=programmer_types.texi
        -P "${CMAKE_CURRENT_SOURCE_DIR}/programmer_types.cmake"
    VERBATIM
    )

add_custom_command(
    OUTPUT parts.texi
    DEPENDS parts.txt
    COMMAND ${CMAKE_COMMAND}
        -D TXT_FILE=parts.txt
        -D TEXI_FILE=parts.texi
        -D COMMENTS_FILE=${CMAKE_CURRENT_SOURCE_DIR}/parts_comments.txt
        -P "${CMAKE_CURRENT_SOURCE_DIR}/parts.cmake"
    VERBATIM
    )

add_custom_command(
    OUTPUT version.texi
    COMMAND ${CMAKE_COMMAND} -E echo "@set EDITION ${DOCS_VERSION}" > version.texi
    COMMAND ${CMAKE_COMMAND} -E echo "@set VERSION ${DOCS_VERSION}" >> version.texi
    COMMAND ${CMAKE_COMMAND} -E echo "@set UPDATED ${DOCS_UPDATED}" >> version.texi
    VERBATIM
    )

# =====================================
# Custom rules for output files
# =====================================

add_custom_command(
    OUTPUT avrdude.info
    COMMAND ${MAKEINFO_EXECUTABLE} -o avrdude.info ${TEXINFOS}
    DEPENDS ${TEXINFOS} ${GENERATED_TEXINFOS}
    VERBATIM
    )

add_custom_command(
    OUTPUT avrdude.dvi
    COMMAND ${MAKEINFO_EXECUTABLE}
        --dvi
        --Xopt=--quiet
        --Xopt=--build-dir=dvi
        -o avrdude.dvi
        ${TEXINFOS}
    DEPENDS ${TEXINFOS} ${GENERATED_TEXINFOS}
    VERBATIM
    )

add_custom_command(
    OUTPUT avrdude.pdf
    COMMAND ${MAKEINFO_EXECUTABLE}
        --pdf
        --Xopt=--quiet
        --Xopt=--build-dir=pdf
        -o avrdude.pdf
        ${TEXINFOS}
    DEPENDS ${TEXINFOS} ${GENERATED_TEXINFOS}
    VERBATIM
    )

add_custom_command(
    OUTPUT avrdude.ps
    COMMAND ${MAKEINFO_EXECUTABLE}
        --ps
        --Xopt=--quiet
        --Xopt=--build-dir=ps
        -o avrdude.ps
        ${TEXINFOS}
    DEPENDS ${TEXINFOS} ${GENERATED_TEXINFOS}
    VERBATIM
    )

add_custom_command(
    OUTPUT avrdude-html/avrdude.html
    COMMAND ${TEXI2HTML_EXECUTABLE}
        --split=node
        --css-include=avrdude.css
        --output=avrdude-html
        -I ${CMAKE_CURRENT_BINARY_DIR}
        ${TEXINFOS}
    DEPENDS ${TEXINFOS} ${GENERATED_TEXINFOS} avrdude.css
    VERBATIM
    )

# =====================================
# Custom targets for output files
# =====================================

add_custom_target(info ALL DEPENDS avrdude.info)
add_custom_target(dvi ALL DEPENDS avrdude.dvi)
add_custom_target(pdf ALL DEPENDS avrdude.pdf)
add_custom_target(ps ALL DEPENDS avrdude.ps)
add_custom_target(html ALL DEPENDS avrdude-html/avrdude.html)

# =====================================
# Install
# =====================================

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/avrdude.info" DESTINATION ${CMAKE_INSTALL_INFODIR})
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/avrdude.dvi" DESTINATION ${CMAKE_INSTALL_DOCDIR})
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/avrdude.pdf" DESTINATION ${CMAKE_INSTALL_DOCDIR})
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/avrdude.ps" DESTINATION ${CMAKE_INSTALL_DOCDIR})
install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/avrdude-html" DESTINATION ${CMAKE_INSTALL_DOCDIR})

## avrdude 5.10

=== debian/changelog ===
avrdude (5.10-3) unstable; urgency=low

  * debian/patches/01-arduino-auto-reset.patch
    - Fix DTR on/off to make Arduino auto-reset work. (Closes: #587280)
      Patch cherry-picked from upstream.

 -- Michael Biebl <biebl@debian.org>  Sun, 27 Jun 2010 01:57:37 +0200

avrdude (5.10-2) unstable; urgency=low

  * Switch to source format 3.0 (quilt).
    - Drop Build-Depends on quilt.
    - Remove patchsys-quilt.mk include from debian/rules.
    - Remove debian/README.source.
    - Add debian/source/format.
  * Bump Standards-Version to 3.8.4. No further changes.
  * Switch from cdbs to dh v7.
    - Drop Build-Depends on cdbs.
    - Bump Build-Depends on debhelper to (>= 7.0.50).
    - Bump Build-Depends on autotools-dev to (>= 20100122.1) for the
      autotools_dev dh addon.
    - Convert debian/rules to dh.

 -- Michael Biebl <biebl@debian.org>  Mon, 21 Jun 2010 05:46:04 +0200

avrdude (5.10-1) unstable; urgency=low

  * New upstream release.
  * Removed patches:
    - debian/patches/01-kfreebsd.patch (merged upstream)
    - debian/patches/03-freebsd-serial-device.patch (merged upstream)
    - debian/patches/04-am_maintainer_mode.patch (obsolete)
    - debian/patches/99-autoreconf.patch (obsolete)

 -- Michael Biebl <biebl@debian.org>  Tue, 19 Jan 2010 18:57:14 +0100

avrdude (5.9-1) unstable; urgency=low

  * New upstream release.
  * debian/patches/01-kfreebsd.patch
    - Update configure check to correctly detect kfreebsd and set the
      default serial and parallel port accordingly.
  * debian/patches/03-freebsd-serial-device.patch
    - The serial port naming scheme has changed since FreeBSD 6.0 from cuaa?
      to cuad?. Update the configure check and the documentation to reflect
      this change.
  * debian/patches/04-am_maintainer_mode.patch
    - Set AM_MAINTAINER_MODE as it makes patching the build system less
      painful.
  * debian/patches/99-autoreconf.patch
    - Run autoreconf -i for the changes above.

 -- Michael Biebl <biebl@debian.org>  Sun, 17 Jan 2010 14:19:31 +0100

avrdude (5.8-2) unstable; urgency=low

  * Replace libreadline5-dev build dependency with libreadline-dev.
  * Bump Standards-Version to 3.8.3. No further changes.

 -- Michael Biebl <biebl@debian.org>  Wed, 23 Sep 2009 15:10:47 +0200

avrdude (5.8-1) unstable; urgency=low

  * New upstream release.
  * Bump Standards-Version to 3.8.2. No further changes.

 -- Michael Biebl <biebl@debian.org>  Tue, 14 Jul 2009 15:09:17 +0200

avrdude (5.6-1) unstable; urgency=low

  * New upstream release.
  * debian/patches/03-spi_support.patch
    - Removed, merged upstream.
  * debian/patches/04-usbtiny_64bit_fix.patch
    - Removed, fixed upstream.

 -- Michael Biebl <biebl@debian.org>  Tue, 03 Mar 2009 17:43:22 +0100

avrdude (5.5-8) unstable; urgency=low

  * debian/copyright
    - Refer to the versioned GPL-2 file in /usr/share/common-licenses as
      avrdude is released under version 2 of the GPL.
  * debian/rules
    - Include debhelper.mk before any other files as recommended by the cdbs
      documentation.
  * debian/control
    - Wrap Build-Depends.
    - Bump Build-Depends on debhelper to (>= 7).
  * debian/compat
    - Bump debhelper compat level to 7.

 -- Michael Biebl <biebl@debian.org>  Wed, 18 Feb 2009 13:43:47 +0100

avrdude (5.5-7) unstable; urgency=low

  * debian/patches/04-usbtiny_64bit_fix.patch
    - Fix chip programming failures using USBTiny adapters on 64bit systems.
      The res[4] variable is passed to usbtiny_cmd() as char pointer and
      sizeof(char*) evaluates to 8 on 64bit systems. So hardcode the number of
      bytes we want to read instead of using sizeof. (Closes: #511751)

 -- Michael Biebl <biebl@debian.org>  Wed, 14 Jan 2009 07:13:39 +0100

avrdude (5.5-6) unstable; urgency=low

  * debian/patches/03-spi_support.patch
    - Add new commands to avrdude's terminal mode to support direct SPI
      transfers. (Closes: #509130)
      Thanks to Andrew O. Shadoura for the patch.

 -- Michael Biebl <biebl@debian.org>  Thu, 18 Dec 2008 23:41:30 +0100

avrdude (5.5-5) unstable; urgency=low

  * Misc white space cleanups.
  * debian/control
    - Add Vcs-* fields.

 -- Michael Biebl <biebl@debian.org>  Sat, 25 Oct 2008 01:42:20 +0200

avrdude (5.5-4) unstable; urgency=low

  * Switch patch system to quilt.
  * debian/control
    - Add Build-Depends on quilt.
    - Bump Standards-Version to 3.8.0. Add debian/README.source as recommended
      by the new policy.
  * debian/rules
    - Include patchsys-quilt.mk instead of simple-patchsys.mk.
  * debian/patches/series
    - Add all existing patches.
  * Refresh all patches. 

 -- Michael Biebl <biebl@debian.org>  Sat, 19 Jul 2008 03:22:50 +0200

avrdude (5.5-3) unstable; urgency=low

  * debian/avrdude-doc.doc-base
    - Update the Section: field to comply with the new doc-base Manual.
  * debian/control
    - Add ${misc:Depends}.

 -- Michael Biebl <biebl@debian.org>  Tue, 04 Mar 2008 23:17:20 +0100

avrdude (5.5-2) unstable; urgency=low

  * debian/control
    - Bump Standards-Version to 3.7.3. No further changes required.
  * debian/avrdude-doc.doc-base
    - Cleanup unnecessary white spaces.

 -- Michael Biebl <biebl@debian.org>  Tue, 08 Jan 2008 07:39:04 +0100

avrdude (5.5-1) unstable; urgency=low

  * New upstream release.
  * debian/avrdude.docs
    - Install the ChangeLog-2004-2006 file.

 -- Michael Biebl <biebl@debian.org>  Tue, 30 Oct 2007 21:02:48 +0100

avrdude (5.4-2) unstable; urgency=low

  * debian/control
    - Use the new "Homepage:" field to specify the upstream URL. 

 -- Michael Biebl <biebl@debian.org>  Sun, 21 Oct 2007 18:43:24 +0200

avrdude (5.4-1) unstable; urgency=low

  * New upstream release.
  * debian/control
    - Replace Build-Depends: tetex-bin with texlive-latex-base. teTeX has been
      obsoleted and superseded by texlive.

 -- Michael Biebl <biebl@debian.org>  Fri, 18 May 2007 17:00:42 +0200

avrdude (5.3.1-1) unstable; urgency=low

  * New upstream release.


=== debian/control ===
Source: avrdude
Section: electronics
Priority: extra
Maintainer: Michael Biebl <biebl@debian.org>
Build-Depends:
 debhelper (>= 7.0.50),
 autotools-dev (>= 20100122.1),
 texi2html,
 texinfo,
 texlive-latex-base,
 flex,
 bison,
 libncurses5-dev,
 libreadline-dev,
 libusb-dev
Standards-Version: 3.8.4
Vcs-Git: git://git.debian.org/git/users/biebl/avrdude.git
Vcs-Browser: http://git.debian.org/?p=users/biebl/avrdude.git;a=summary
Homepage: http://savannah.nongnu.org/projects/avrdude/

Package: avrdude
Section: electronics
Priority: extra
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: avrdude-doc
Description: software for programming Atmel AVR microcontrollers
 AVRDUDE is an open source utility to download/upload/manipulate the
 ROM and EEPROM contents of AVR microcontrollers using the in-system
 programming technique (ISP).

Package: avrdude-doc
Section: doc
Priority: extra
Architecture: all
Depends: ${misc:Depends}
Suggests: doc-base
Description: documentation for avrdude
 AVRDUDE is an open source utility to download/upload/manipulate the
 ROM and EEPROM contents of AVR microcontrollers using the in-system
 programming technique (ISP).
 .
 This package contains documentation for configuring and running
 AVRDUDE.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with autotools_dev

override_dh_auto_configure:
	dh_auto_configure -- --enable-versioned-doc=no --enable-doc

## avrdude 5.11

=== debian/changelog ===
avrdude (5.11-1) unstable; urgency=low

  * New upstream release.
  * Bump debhelper compatibility level to 8 and update build dependency
    accordingly.
  * Bump Standards-Version to 3.9.2. No further changes.
  * Remove debian/patches/01-arduino-auto-reset.patch, merged upstream.
  * Refresh debian/patches/02-manpage_fix.patch.
  * Add support for FT2232 based programmers by building against libftdi.

 -- Michael Biebl <biebl@debian.org>  Sun, 28 Aug 2011 14:30:26 +0200

## avrdude 5.11.1

=== debian/changelog ===
avrdude (5.11.1-2) unstable; urgency=low

  * Move package to collab-maint.
  * Bump Standards-Version to 3.9.4.
  * Bump debhelper compatibility level to 9.

 -- Michael Biebl <biebl@debian.org>  Sun, 24 Mar 2013 01:49:52 +0100

avrdude (5.11.1-1) unstable; urgency=low

  * New upstream release.
  * Install ChangeLog files for 2007-2009.

 -- Michael Biebl <biebl@debian.org>  Tue, 18 Oct 2011 23:06:14 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: Michael Biebl <biebl@debian.org>
 Build-Depends:
- debhelper (>= 7.0.50),
+ debhelper (>= 9),
  autotools-dev (>= 20100122.1),
  texi2html,
  texinfo,
@@ -12,10 +12,11 @@
  bison,
  libncurses5-dev,
  libreadline-dev,
- libusb-dev
-Standards-Version: 3.8.4
-Vcs-Git: git://git.debian.org/git/users/biebl/avrdude.git
-Vcs-Browser: http://git.debian.org/?p=users/biebl/avrdude.git;a=summary
+ libusb-dev,
+ libftdi-dev
+Standards-Version: 3.9.4
+Vcs-Git: git://anonscm.debian.org/collab-maint/avrdude.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/avrdude.git;a=summary
 Homepage: http://savannah.nongnu.org/projects/avrdude/
 
 Package: avrdude

## avrdude 6.0.1

=== debian/changelog ===
avrdude (6.0.1-1) unstable; urgency=low

  * New upstream release.
  * Add Build-Depends on libelf-dev to enable support for reading ELF files.
  * Enable the Linux sysfs GPIO interface programmer type when building on
    Linux.

 -- Michael Biebl <biebl@debian.org>  Fri, 20 Sep 2013 20:32:13 +0200

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,8 @@
  libncurses5-dev,
  libreadline-dev,
  libusb-dev,
- libftdi-dev
+ libftdi-dev,
+ libelf-dev
 Standards-Version: 3.9.4
 Vcs-Git: git://anonscm.debian.org/collab-maint/avrdude.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/avrdude.git;a=summary

=== debian/rules ===
#!/usr/bin/make -f

ifeq ($(DEB_HOST_ARCH_OS),linux)
	CONFFLAGS += --enable-linuxgpio
endif
%:
	dh $@ --with autotools_dev

override_dh_auto_configure:
	dh_auto_configure -- \
		--enable-versioned-doc=no \
		--enable-doc \
		$(CONFFLAGS)

=== debian/watch ===
version=3
http://savannah.nongnu.org/download/avrdude/avrdude-([\d\.]*)\.tar\.gz

## avrdude 6.1

=== debian/changelog ===
avrdude (6.1-4build1) wily; urgency=medium

  * No-change rebuild for libstdc++6 ABI changes.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 08 Sep 2015 11:36:45 +0200

avrdude (6.1-4) unstable; urgency=medium

  [ Michael Biebl ]
  * Update watch file to also track .bz2 and .xz tarballs.
  * Add cryptographic signature verification for upstream tarball.
  * Make no-patch-numbers the default for gbp.

  [ Guido Günther ]
  * Avoid division by zero on empty size. Patch cherry-picked from upstream.
    (Closes: #788517)

 -- Michael Biebl <biebl@debian.org>  Fri, 12 Jun 2015 12:49:43 +0200

avrdude (6.1-3) unstable; urgency=medium

  * Bump Standards-Version to 3.9.6. No further changes.
  * Update Vcs-Browser URL to use cgit and https.
  * Fix Linux GPIO typo. Patch cherry-picked from upstream. (Closes: #745034)

 -- Michael Biebl <biebl@debian.org>  Fri, 01 May 2015 05:22:06 +0200

avrdude (6.1-2) unstable; urgency=medium

  * Fix reset on FT245R. Patch cherry-picked from upstream. (Closes: #760764)

 -- Michael Biebl <biebl@debian.org>  Thu, 11 Sep 2014 21:56:06 +0200

avrdude (6.1-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Bump Standards-Version to 3.9.5. No further changes.

 -- Michael Biebl <biebl@debian.org>  Fri, 14 Mar 2014 15:30:25 +0100

=== debian/control ===
--- 
+++ 
@@ -15,9 +15,9 @@
  libusb-dev,
  libftdi-dev,
  libelf-dev
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Vcs-Git: git://anonscm.debian.org/collab-maint/avrdude.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/avrdude.git;a=summary
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/avrdude.git
 Homepage: http://savannah.nongnu.org/projects/avrdude/
 
 Package: avrdude

## avrdude 6.2

=== debian/changelog ===
avrdude (6.2-5) unstable; urgency=medium

  * Set ISO 8601 formatted postscript CreationDate.

 -- Milan Kupcevic <milan@debian.org>  Sat, 02 Jan 2016 09:59:25 -0500

avrdude (6.2-4) unstable; urgency=medium

  * Update udev rules.
  * Set reproducible postscript CreationDate field.

 -- Milan Kupcevic <milan@debian.org>  Fri, 01 Jan 2016 21:47:30 -0500

avrdude (6.2-3) unstable; urgency=low

  * No CPP macro timestamps.
  * Use tbl man preprocessor.
  * Use makeinfo instead of texi2html.
  * Include all ChangeLog files.
  * Add udev device rules. (Closes: #666137)

 -- Milan Kupcevic <milan@debian.org>  Sun, 27 Dec 2015 23:22:32 -0500

avrdude (6.2-2) unstable; urgency=low

  * New maintainer (closes: #805651). Many thanks to Michael Biebl for a 
    decade worth of contributions to this package.
  * Set proper serial device attributes. (Closes: #805642)

 -- Milan Kupcevic <milan@debian.org>  Sat, 19 Dec 2015 14:46:10 -0500

avrdude (6.2-1) unstable; urgency=medium

  * New upstream release. (Closes: #805352)
  * Rebase patches.
  * Override dh_install to list uninstalled files.
  * Use .install files to install the avrdude man page and info file.
  * Install html, pdf and ps documentation under /usr/share/doc/avrdude, as
    this is the location where upstream puts it.
  * Add symlinks in /usr/share/doc/avrdude-doc so the old paths still work.

 -- Michael Biebl <biebl@debian.org>  Tue, 17 Nov 2015 15:01:26 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,13 @@
 Source: avrdude
 Section: electronics
 Priority: extra
-Maintainer: Michael Biebl <biebl@debian.org>
+Maintainer: Milan Kupcevic <milan@debian.org>
 Build-Depends:
  debhelper (>= 9),
  autotools-dev (>= 20100122.1),
- texi2html,
+ autoconf,
+ automake,
+ ghostscript,
  texinfo,
  texlive-latex-base,
  flex,
@@ -21,8 +23,6 @@
 Homepage: http://savannah.nongnu.org/projects/avrdude/
 
 Package: avrdude
-Section: electronics
-Priority: extra
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Suggests: avrdude-doc
@@ -33,8 +33,8 @@
 
 Package: avrdude-doc
 Section: doc
-Priority: extra
 Architecture: all
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}
 Suggests: doc-base
 Description: documentation for avrdude

=== debian/rules ===
--- 
+++ 
@@ -11,3 +11,6 @@
 		--enable-versioned-doc=no \
 		--enable-doc \
 		$(CONFFLAGS)
+
+override_dh_install:
+	dh_install --list-missing

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.sig/ http://savannah.nongnu.org/download/avrdude/avrdude-([\d\.]*)\.tar\.(?:gz|bz2|xz)

## avrdude 6.3

=== debian/changelog ===
avrdude (6.3-4) unstable; urgency=medium

  * Support ATtiny841 and ATtiny441
  * Bump Standards-Version to 4.0.0
  * Full auto-reconfigure on builds

 -- Milan Kupcevic <milan@debian.org>  Sun, 06 Aug 2017 18:28:55 -0400

avrdude (6.3-3) unstable; urgency=medium

  * Recreate aclocal.m4 (closes: #868925)
  * Set package priority to overridden optional.

 -- Milan Kupcevic <milan@debian.org>  Wed, 26 Jul 2017 16:30:50 -0400

avrdude (6.3-2) unstable; urgency=medium

  * Do not mask unused lock byte bits on read (closes: #809002)

 -- Milan Kupcevic <milan@debian.org>  Mon, 05 Dec 2016 19:27:46 -0500

avrdude (6.3-1) unstable; urgency=medium

  * New upstream release (closes: #821033)
    - set proper serial device attributes (closes: 805642), patch removed
  * Fix linuxgpio conversion failure. Upstream bug#47550 patch.
  * Update Vcs-Git to use secure transport for anonymous git repository access.
  * Bump Standards-Version to 3.9.8. No changes.

 -- Milan Kupcevic <milan@debian.org>  Wed, 18 May 2016 23:43:38 -0400

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: avrdude
 Section: electronics
-Priority: extra
+Priority: optional
 Maintainer: Milan Kupcevic <milan@debian.org>
 Build-Depends:
  debhelper (>= 9),
  autotools-dev (>= 20100122.1),
+ dh-autoreconf,
  autoconf,
  automake,
  ghostscript,
@@ -17,8 +18,8 @@
  libusb-dev,
  libftdi-dev,
  libelf-dev
-Standards-Version: 3.9.6
-Vcs-Git: git://anonscm.debian.org/collab-maint/avrdude.git
+Standards-Version: 4.0.0
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/avrdude.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/avrdude.git
 Homepage: http://savannah.nongnu.org/projects/avrdude/

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 	CONFFLAGS += --enable-linuxgpio
 endif
 %:
-	dh $@ --with autotools_dev
+	dh $@ --with autotools_dev --with autoreconf
 
 override_dh_auto_configure:
 	dh_auto_configure -- \

## avrdude 6.3-20171130+svn1429

=== debian/changelog ===
avrdude (6.3-20171130+svn1429-2) sid; urgency=medium

  * revert usbtiny tpi implementation (closes: #922558)

 -- Milan Kupcevic <milan@debian.org>  Mon, 25 Feb 2019 01:51:58 -0500

avrdude (6.3-20171130+svn1429-1) sid; urgency=medium

  * new upstream release
  * remove upstream accepted patches
  * add new devices to metainfo, udev rules
  * use libhidapi

 -- Milan Kupcevic <milan@debian.org>  Tue, 12 Feb 2019 02:25:09 -0500

avrdude (6.3-6) sid; urgency=medium

  * update metainfo release license
  * udev: permit console users use usb serial adapters
  * update standards version to 4.3.0

 -- Milan Kupcevic <milan@debian.org>  Mon, 24 Dec 2018 17:06:16 -0500

avrdude (6.3-5) sid; urgency=medium

  * Update package maintenance Vcs-* fields
  * Use 'uaccess' tag in udev rules
  * Suggest dfu-programmer
  * Provide package metainfo
  * No direct libncurses5-dev build dependency
  * autotools-dev is not needed anymore
  * use dh_missing
  * Define optional posix limits to allow building on GNU/Hurd
  * Bump Standards-Version to 4.2.1
  * Use debian watch secure uri
  * avrpart.c: correct a spelling mistake

 -- Milan Kupcevic <milan@debian.org>  Mon, 17 Dec 2018 17:21:43 -0500

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,7 @@
 Priority: optional
 Maintainer: Milan Kupcevic <milan@debian.org>
 Build-Depends:
- debhelper (>= 9),
- autotools-dev (>= 20100122.1),
+ debhelper (>= 9.20160114),
  dh-autoreconf,
  autoconf,
  automake,
@@ -13,20 +12,20 @@
  texlive-latex-base,
  flex,
  bison,
- libncurses5-dev,
  libreadline-dev,
+ libhidapi-dev,
  libusb-dev,
  libftdi-dev,
  libelf-dev
-Standards-Version: 4.0.0
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/avrdude.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/avrdude.git
+Standards-Version: 4.3.0
+Vcs-Git: https://salsa.debian.org/debian/avrdude.git
+Vcs-Browser: https://salsa.debian.org/debian/avrdude
 Homepage: http://savannah.nongnu.org/projects/avrdude/
 
 Package: avrdude
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Suggests: avrdude-doc
+Suggests: dfu-programmer, avrdude-doc
 Description: software for programming Atmel AVR microcontrollers
  AVRDUDE is an open source utility to download/upload/manipulate the
  ROM and EEPROM contents of AVR microcontrollers using the in-system

=== debian/rules ===
#!/usr/bin/make -f

ifeq ($(DEB_HOST_ARCH_OS),linux)
	CONFFLAGS += --enable-linuxgpio
endif
%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- \
		--enable-versioned-doc=no \
		--enable-doc \
		$(CONFFLAGS)

override_dh_missing:
	dh_missing --list-missing

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.sig/ https://download.savannah.gnu.org/releases/avrdude/avrdude-([\d\.]*)\.tar\.(?:gz|bz2|xz)

## avrdude 7.1+dfsg

=== debian/changelog ===
avrdude (7.1+dfsg-3) sid; urgency=medium

  * clarify documentation license GFDL-NIV-1.3; no identifiable invariant sections
    exist in the document

 -- Milan Kupcevic <milan@debian.org>  Fri, 10 Mar 2023 22:17:35 -0500

avrdude (7.1+dfsg-2) sid; urgency=medium

  * add autopkgtest
  * exclude libhidapi-dev on hurd
  * use permissive metainfo metadata_license as required by the AppStream
    specification
  * upstream forwarding not needed for debian specific patches

 -- Milan Kupcevic <milan@debian.org>  Fri, 10 Mar 2023 08:24:31 -0500

avrdude (7.1+dfsg-1) sid; urgency=medium

  * new upstream release
    - support teensy bootloader (closes: #629360)
    - support ATtiny2313A (closes: #909573)
  * remove upstream accepted patches
  * remove upstream tarball signature verification
  * quilt refresh
  * update standards version to 4.6.2
  * bump debhelper compat level to 12
  * debian/copyright: update, exclude non-dfsg files (closes: #979090)
    - lintian override undefined license
    - fix short beer-ware license id
  * update metainfo release license
  * use texi2html instead of makeinfo for pretty html docs (closes: #1030364)
    (lp: #1783814)
  * use dh_installman
  * use dh_installinfo
  * proper AppStrem metainfo id
  * add new devices to metainfo, udev rules
  * enable linuxspi

 -- Milan Kupcevic <milan@debian.org>  Wed, 08 Mar 2023 20:53:51 -0500

=== debian/control ===
--- 
+++ 
@@ -3,24 +3,23 @@
 Priority: optional
 Maintainer: Milan Kupcevic <milan@debian.org>
 Build-Depends:
- debhelper (>= 9.20160114),
- dh-autoreconf,
+ debhelper (>= 12.1.1),
  autoconf,
  automake,
  ghostscript,
+ texi2html,
  texinfo,
  texlive-latex-base,
  flex,
  bison,
  libreadline-dev,
- libhidapi-dev,
+ libhidapi-dev [!hurd-i386],
  libusb-dev,
  libftdi-dev,
  libelf-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/debian/avrdude.git
-Vcs-Browser: https://salsa.debian.org/debian/avrdude
-Homepage: http://savannah.nongnu.org/projects/avrdude/
+Homepage: https://github.com/avrdudes/avrdude/
 
 Package: avrdude
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,10 @@
 #!/usr/bin/make -f
 
 ifeq ($(DEB_HOST_ARCH_OS),linux)
-	CONFFLAGS += --enable-linuxgpio
+	CONFFLAGS += --enable-linuxgpio --enable-linuxspi
 endif
 %:
-	dh $@ --with autoreconf
+	dh $@ --with autoreconf --sourcedirectory=src
 
 override_dh_auto_configure:
 	dh_auto_configure -- \

=== debian/tests/control ===
Test-Command: avrdude -?
Depends: avrdude
Restrictions: allow-stderr
